Attribute VB_Name = "RecycleBinMod"
' All code Copyright (C) 2001-2003 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.
'
' A small amount of this code is based Microsoft's example source code
'  and is assumed to be public domain as no copyright was claimed

Private Type SHFILEOPSTRUCT
   hWnd        As Long
   wFunc       As Long
   pFrom       As String
   pTo         As String
   fFlags      As Integer
   fAborted    As Boolean
   hNameMaps   As Long
   sProgress   As String
 End Type
  
Private Const FO_DELETE = &H3
Private Const FOF_ALLOWUNDO = &H40

Private Declare Function SHFileOperation Lib "shell32" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long

Public Sub Recycle(FilePath As String)
 
   Dim SHFileOp As SHFILEOPSTRUCT
 
  'terminate the file string with Chr$(0)
   FilePath = FilePath & Chr$(0)
 
  'set up the SHFile options
   With SHFileOp
      .wFunc = &H3
      .pFrom = FilePath
      .fFlags = &H40
   End With
 
  'and perform the delete
   Call SHFileOperation(SHFileOp)

End Sub

