VERSION 5.00
Begin VB.Form helpForm 
   Caption         =   "Form1"
   ClientHeight    =   4125
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4605
   LinkTopic       =   "Form1"
   ScaleHeight     =   4125
   ScaleWidth      =   4605
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   4095
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "helpForm.frx":0000
      Top             =   0
      Width           =   4575
   End
End
Attribute VB_Name = "helpForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' All code Copyright (C) 2001 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.

Private Sub Form_Load()
Me.Icon = mainForm.Icon
Me.Caption = App.Title & " - " & LANGPACK.SeeByName("HELP")
Me.Width = mainForm.Width



End Sub

' Load the given file into the form
Private Sub Load_File(FilePath As String)
    ' Clear it out first
    Text1.Text = ""
    Dim hlinez As MArray
    Set hlinez = Get_Lines(FilePath, False)
    Text1.Text = hlinez.Shift & NL
    While (hlinez.size > 0)
        Text1.Text = Text1.Text & hlinez.Shift & NL
    Wend
End Sub

'Publicly exposed function to load the ChangeLog into the form
Public Sub Load_ChangeLog()

    Load_File App.Path & "\ChangeLog.txt"
    
End Sub

'Publicly exposed function to load the appropriate README into the form
Public Sub Load_Readme()
    Dim lRF As String
    lRF = App.Path & "\langs\readme." & LANGCHOICE
    If (Not File_Exists(lRF)) Then
        'If there isn't a Readme translation for the current language,
        ' load the English one.
        lRF = App.Path & "\langs\readme.lang.eng0.txt"
    End If

    Load_File lRF
    
End Sub

Private Sub Form_Resize()

'Keep it consistent
If (Me.WindowState <> 1) Then
    Text1.Height = Me.Height - 435
    Text1.Width = Me.Width - 150
End If
End Sub
