VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form mainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   3015
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5805
   Icon            =   "mainForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3015
   ScaleWidth      =   5805
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer UpdateTimer 
      Enabled         =   0   'False
      Interval        =   5000
      Left            =   5160
      Top             =   1080
   End
   Begin VB.PictureBox DnDPic 
      AutoSize        =   -1  'True
      Height          =   2595
      Left            =   0
      OLEDropMode     =   1  'Manual
      Picture         =   "mainForm.frx":030A
      ScaleHeight     =   2535
      ScaleWidth      =   5745
      TabIndex        =   1
      Top             =   0
      Width           =   5805
      Begin MSComDlg.CommonDialog FileBrowser 
         Left            =   5160
         Top             =   1440
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   393216
         DefaultExt      =   "*.*"
         DialogTitle     =   "Save As"
         FileName        =   "SimFileMaidInstaller.exe"
      End
      Begin VB.CommandButton HelpButton 
         Height          =   615
         Left            =   5160
         Picture         =   "mainForm.frx":2FBCC
         Style           =   1  'Graphical
         TabIndex        =   2
         ToolTipText     =   "Help!"
         Top             =   1920
         Width           =   615
      End
      Begin VB.PictureBox rackPicture 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         BorderStyle     =   0  'None
         ForeColor       =   &H80000008&
         Height          =   2400
         Left            =   3420
         OLEDropMode     =   1  'Manual
         ScaleHeight     =   2400
         ScaleWidth      =   2295
         TabIndex        =   3
         Top             =   10
         Width           =   2295
      End
   End
   Begin MSComctlLib.StatusBar SBar 
      Align           =   2  'Align Bottom
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   2640
      Width           =   5805
      _ExtentX        =   10239
      _ExtentY        =   661
      Style           =   1
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   1
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
         EndProperty
      EndProperty
   End
   Begin VB.Menu helpMenu 
      Caption         =   "Help"
      Visible         =   0   'False
      Begin VB.Menu helpMenuOption 
         Caption         =   "Help"
      End
      Begin VB.Menu sfmwebMenuOption 
         Caption         =   "Sim File Maid Website!"
      End
      Begin VB.Menu updateCheckMenuOption 
         Caption         =   "Check for Updates Now!"
         Enabled         =   0   'False
         Visible         =   0   'False
      End
      Begin VB.Menu sepbar2 
         Caption         =   "-"
      End
      Begin VB.Menu rackMenuOption 
         Caption         =   "Rack Options"
      End
      Begin VB.Menu langMenuOption 
         Caption         =   "Language Options"
      End
      Begin VB.Menu logMenuOption 
         Caption         =   "Logging Options"
      End
      Begin VB.Menu otherMenuOptions 
         Caption         =   "Other Options"
      End
      Begin VB.Menu sepbar1 
         Caption         =   "-"
      End
      Begin VB.Menu changeLogMenu 
         Caption         =   "ChangeLog"
      End
      Begin VB.Menu aboutMenuOption 
         Caption         =   "Credits"
      End
   End
End
Attribute VB_Name = "mainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' All code Copyright (C) 2000 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.

Option Explicit


Public Sub Handle_Processing(Data As MArray)
' Set the status bar to show what we're doing
    SBar.SimpleText = LANGPACK.SeeByName("Processing") & "..."
    
    ' Set the mouse pointer to hourglass
    Me.MousePointer = 11
    
    Write_Log "HANDLEPROCCOUNT: " & CStr(Data.Size), 4
    
    Dim installCount As Long
    installCount = 0
    
    ' Iterate though all of the files dropped onto The Lawn
    While Data.Size > 0
        Dim DataFilePath As String
        
        DataFilePath = CStr(Data.Pop)
    
        ' do the right thing
        If (GetAttr(DataFilePath) And vbDirectory) = vbDirectory Then
            ' DataFilePath is a directory: recurse it
            
            'Log it
            Write_Log "FOLDER: " & DataFilePath
            
            Dim DitPath As String, DitItem As String
            DitPath = DataFilePath & "\"   ' Set the path.
            DitItem = Dir(DitPath, vbDirAllFilesFolders)  ' Retrieve the first entry.
            While (DitItem <> "")
                ' Ignore the current directory and the encompassing directory.
                If DitItem <> "." And DitItem <> ".." Then
                    'Add the file to the Data.Files array
                    Data.Push (DitPath & DitItem)
                End If
                DitItem = Dir   ' Get next entry.
            Wend
        Else
            If (Len(SBar.SimpleText) < 50) Then
                ' Add up to 50 characters filled out with dots
                SBar.SimpleText = SBar.SimpleText + "."
            Else
                ' Still going...
                SBar.SimpleText = LANGPACK.SeeByName("STILLPROC")
            End If
            ' DataFilePath is a file, handle it, then remove its entry
            installCount = installCount + Handle_File(CStr(DataFilePath))
        End If
    Wend

    ' Grammar handling
    Dim CompleteMsg As String
    If (installCount > 1) Then
        CompleteMsg = LANGPACK.ProperString("PLURALFILES", CStr(installCount))
    ElseIf (installCount = 0) Then
        CompleteMsg = LANGPACK.SeeByName("NOFILES")
    Else
        CompleteMsg = LANGPACK.SeeByName("Singularfile")
    End If
    
    Write_Log "POSTINSTALL: " & CStr(installCount) & " files installed", 4
    'Set the status bar to the state, reset the mouse pointer
    SBar.SimpleText = LANGPACK.SeeByName("Done") & " " & CompleteMsg
    Me.MousePointer = 0
End Sub

' What to do... What to do...
Sub Handle_DnD(DObj As DataObject, Optional X As Single = 0)
    Dim AObj As MArray
    Set AObj = New MArray
    
    Write_Log "HANDLEDODFILECOUNT: " & CStr(DObj.Files.Count), 4
    
    ' Figure out what they want to do with this stuff
    If (X <= 660) Then
        ' They dropped on The Maid, the sillies.
        Handle_Information LANGPACK.SeeByName("MAIDDROP")
    ElseIf ((X < 3420) Or (TheRack = False)) Then
        ' They dropped on The Lawn!
        Write_Log "LAWN", 4
    
        'convert dataobject to MArray
        While DObj.Files.Count > 0
            AObj.Push DObj.Files.Item(DObj.Files.Count)
            DObj.Files.Remove (DObj.Files.Count)
        Wend
    
        ' Make magic
        Handle_Processing AObj
        
    Else 'If (x >= 3420) Then
        ' They dropped on The Rack.
        While (RackData <> "abort")
            
            RackData = DObj.Files.Item(DObj.Files.Count)
            
            ' Check to make sure they're BMP files, thus saving
            '   the user from themselves
            If (LCase(Right(RackData, 4)) = ".bmp") Then
                ' it's legit, show the box modally
                TheRackDialog.Show vbModal
            Else
                ' Grrr, why can't people read
                Handle_Information LANGPACK.ProperString("RACKNOBMP", RackData)
            End If
            
            DObj.Files.Remove (DObj.Files.Count)
            
            ' This is a stupid trap because I couldn't figure out how to end
            '   the loop easier.
            If (DObj.Files.Count <= 0) Then
                RackData = "abort"
            End If
        Wend
    End If
    
    RackData = "waiting"
End Sub



Private Sub aboutMenuOption_Click()

    CreditsFlag = True
    Me.Hide
    frmAbout.Show vbModal
    Me.Show
    CreditsFlag = False
    
End Sub



Private Sub changeLogMenu_Click()
    helpForm.Load_ChangeLog
    helpForm.Show
End Sub

'When someone right-clicks, do the Right Thing
Private Sub DnDPic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    If (Button = 2) Then
        ' A right click
        PopupMenu helpMenu
    End If
    
End Sub

'This is what happens when someone executes a drag-and-drop
Private Sub DnDPic_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    
        Handle_DnD Data, X
        
End Sub

Private Sub Form_Load()

On Error GoTo MAINLOADERR

'set the damned newline
 NL = Chr(13) & Chr(10)
 CreditsFlag = False

' Set the app caption
Me.Caption = App.Title & " - " & App.Major & "." & App.Minor & " Build " & App.Revision & " - FINAL"

'##################################################################
' handle language crap

' If they haven't picked a language, make them pick it.
If (Len(GetSetting(App.Title, "Settings", "LangChoice")) = 0) Then
    langPickForm.Show vbModal
End If

' Get the language
LANGCHOICE = GetSetting(App.Title, "Settings", "LangChoice")

' If the language pack doesn't exist, or they're lame and didn't pick like
'   they were supposed to, make 'em pick again... and again... and again...
'   until they do it right. Argh.
While (Not File_Exists(App.Path & "\langs\" & LANGCHOICE))
    langPickForm.Show vbModal
    LANGCHOICE = GetSetting(App.Title, "Settings", "LangChoice")
Wend

'ok, load it
Call Load_Language
'##################################################################

' Handle LogLevel handling
LogLevel = 3

' If there is another copy running, kill this instance.
If (App.PrevInstance) Then
    Handle_Critical LANGPACK.SeeByName("AnotherMaid"), True
End If

'Log the startup
Write_Log App.Title & " - " & App.Major & "." & App.Minor & " Build " & App.Revision

If (Len(GetSetting(App.Title, "Settings", "LogLevel"))) Then
    Select Case LCase(GetSetting(App.Title, "Settings", "LogLevel"))
        Case "off"
            'turns logging off altogether
            LogLevel = 0
        Case "errors"
            'only logs errors
            LogLevel = 1
        Case "skips"
            'Only log skipped files (and errors)
            LogLevel = 2
        Case "verbose"
            'Logs everything except debugging crap (default)
            LogLevel = 3
        Case "debug"
            'Very crazy, you probably don't want this.
            LogLevel = 4
        Case Else
            ' dunno, make it the default
            LogLevel = 3
    End Select
    'Write the loglevel
    Write_Log "LOGLEVEL: " & CStr(LogLevel), 4
Else
    ' Make it the default
    SaveSetting App.Title, "Settings", "LogLevel", "verbose"
End If

'Set the global. This is to fix a problem with users whose C: does't exist or
' is a removable disk. It's happened. Don't ask.
MaidTemp = Get_Drive(App.Path) & "\temp\simfilemaid\simzptemp"
Write_Log "MAIDTEMP: " & MaidTemp, 4

'Log Language
Write_Log "LANGCHOICE: " & LANGCHOICE, 4

' Check for ForceMyPath
If (Len(GetSetting(App.Title, "Settings", "ForceMyPath")) And (LCase(GetSetting(App.Title, "Settings", "ForceMyPath")) = "yes")) Then
    ForceMyPath = True
Else
    ForceMyPath = False
End If

' Ascertain where The Sims is installed and set it into the variable
SimsPath = Get_SimsPath()

'Log SimsPath
Write_Log "SIMSPATH: " & SimsPath, 4

' Check for non existant SimsPath
While ((Not Folder_Exists(SimsPath)) Or (Not IsLetter(SimsPath)))
    Handle_Error LANGPACK.ProperString("NOSIMSPATH", LANGPACK.SeeByName("FORCEVAL"))
    optsForm.Show vbModal
Wend

' Do some heuristics on the Path
'If (Not IsLetter(SimsPath)) Then
'    Handle_Error LANGPACK.ProperString("BADINSTALL", SimsPath), True
'End If

'### Handle Path hacks

'Set the defaults
SimsObjectPath = "GameData\UserObjects"
SimsSkinsPath = "GameData\Skins"
SimsFloorPath = "GameData\Floors"
SimsWallPath = "GameData\Walls"
SimsArchivePath = "Downloads"

' Allow the kiddies to tweak
If (Len(GetSetting(App.Title, "Settings", "SimsObjectPath"))) Then
    SimsObjectPath = GetSetting(App.Title, "Settings", "SimsObjectPath")
    Write_Log "SIMSOBJECTPATH: " & SimsObjectPath, 4
Else
    SaveSetting App.Title, "Settings", "SimsObjectPath", SimsObjectPath
End If

If (Len(GetSetting(App.Title, "Settings", "SimsSkinPath"))) Then
    SimsSkinsPath = GetSetting(App.Title, "Settings", "SimsSkinPath")
    Write_Log "SIMSSKINPATH: " & SimsSkinsPath, 4
Else
    SaveSetting App.Title, "Settings", "SimsSkinPath", SimsSkinsPath
End If

If (Len(GetSetting(App.Title, "Settings", "SimsFloorPath"))) Then
    SimsFloorPath = GetSetting(App.Title, "Settings", "SimsFloorPath")
    Write_Log "SIMSFLOORPATH: " & SimsFloorPath, 4
Else
    SaveSetting App.Title, "Settings", "SimsFloorPath", SimsFloorPath
End If

If (Len(GetSetting(App.Title, "Settings", "SimsWallPath"))) Then
    SimsWallPath = GetSetting(App.Title, "Settings", "SimsWallPath")
    Write_Log "SIMSWALLPATH: " & SimsWallPath, 4
Else
    SaveSetting App.Title, "Settings", "SimsWallPath", SimsWallPath
End If

If (Len(GetSetting(App.Title, "Settings", "SimsArchivePath"))) Then
    SimsArchivePath = GetSetting(App.Title, "Settings", "SimsArchivePath")
    Write_Log "SIMSARCHIVEPATH: " & SimsArchivePath, 4
Else
    SaveSetting App.Title, "Settings", "SimsArchivePath", SimsArchivePath
End If


' Handle the UpdateDays parameter
If (Len(GetSetting(App.Title, "Settings", "UpdateDays"))) Then
    UpdateDays = CInt(GetSetting(App.Title, "Settings", "UpdateDays"))
    Write_Log "UPDATEDAYS: " & CStr(UpdateDays), 4
Else
    'Set the default
    UpdateDays = 3
    SaveSetting App.Title, "Settings", "UpdateDays", CStr(UpdateDays)
End If

' Handle ShowRack handling
TheRack = True
If (Len(GetSetting(App.Title, "Settings", "ShowRack"))) Then
    If (LCase(GetSetting(App.Title, "Settings", "ShowRack")) = "no") Then
        Write_Log "SHOWRACK OFF", 4
        TheRack = False
        rackPicture.Visible = False
        rackMenuOption.Enabled = False
    End If
Else
    ' Make it the default
    SaveSetting App.Title, "Settings", "ShowRack", "yes"
End If

' Handle ConfirmOverwrites handling
ConfirmOverwrites = False
OverwriteReject = False
If (Len(GetSetting(App.Title, "Settings", "ConfirmOverwrites"))) Then
    If (LCase(GetSetting(App.Title, "Settings", "ConfirmOverwrites")) = "yes") Then
        Write_Log "CONFIRMOVERWRITES ON", 4
        ConfirmOverwrites = True
    ElseIf (LCase(GetSetting(App.Title, "Settings", "ConfirmOverwrites")) = "reject") Then
        ' They want to auto-reject overwrites
        Write_Log "REJECTOVERWRITES ON", 4
        OverwriteReject = True
    End If
Else
    ' Make it the default
    SaveSetting App.Title, "Settings", "ConfirmOverwrites", "no"
End If

' Handle SkipEXE handling
SkipEXEs = False
If (Len(GetSetting(App.Title, "Settings", "SkipEXEs"))) Then
    If (LCase(GetSetting(App.Title, "Settings", "SkipEXEs")) = "yes") Then
        Write_Log "SkipEXEs ON", 4
        SkipEXEs = True
    End If
Else
    ' Make it the default
    SaveSetting App.Title, "Settings", "SkipEXEs", "no"
End If

' Handle UpdateCheck
UpdateCheck = False
If (Len(GetSetting(App.Title, "Settings", "UpdateCheck"))) Then
    If (LCase(GetSetting(App.Title, "Settings", "UpdateCheck")) = "yes") Then
        Write_Log "UpdateCheck ON", 4
        UpdateCheck = True
    End If
Else
    ' Make it the default
    SaveSetting App.Title, "Settings", "UpdateCheck", "no"
End If

' Handle TrashCMXWithSkinIfUnused
TrashCMXWithSkinIfUnused = False
If (Len(GetSetting(App.Title, "Settings", "TrashCMXWithSkinIfUnused"))) Then
    If (LCase(GetSetting(App.Title, "Settings", "TrashCMXWithSkinIfUnused")) = "yes") Then
        Write_Log "TrashCMXWithSkinIfUnused ON", 4
        TrashCMXWithSkinIfUnused = True
    End If
Else
    ' Make it the default
    SaveSetting App.Title, "Settings", "TrashCMXWithSkinIfUnused", "no"
End If

'Handle BadZipAlertBox
BadZipAlertBox = True
If (Len(GetSetting(App.Title, "Settings", "BadZipAlertBox"))) Then
    If (LCase(GetSetting(App.Title, "Settings", "BadZipAlertBox")) = "no") Then
        Write_Log "BadZipAlertBox OFF", 4
        BadZipAlertBox = False
    End If
End If

'********* Rack check
If (TheRack) Then
    While (Len(GetSetting(App.Title, "Settings", "RackChoice")) <= 1)
        ' First time!
        Write_Log "RACK: First time!!!!", 4
        Me.Hide
        maidsChooseform.Show vbModal
        Me.Show
    Wend
    
    ' set The Rack picture and continue
    Dim rackChoice As String
    rackChoice = GetSetting(App.Title, "Settings", "RackChoice")
    Write_Log "RACK: " & rackChoice, 4
    rackPicture.Picture = LoadPicture(App.Path & "\racks\" & rackChoice)
    rackPicture.AutoSize = True
End If

' Set the status bar to the default message
DefBarMsg = LANGPACK.SeeByName("DefBarMsg")
SBar.SimpleText = DefBarMsg

' Check to see if there are files to install from command line
If (Len(Command) > 0) Then
    ' Files have been specified on the command line
    Write_Log "CMD", 4
    
    Dim Command_Array As MArray
    Set Command_Array = New MArray
    
    ' Initialize the array, setting the CommandFileFormatFlag so
    '   it does the Right Thing(tm)
    Command_Array.Initialize Command, True
    
    ' Deal with the stuff
    Handle_Processing Command_Array
    
    Write_Log "/CMD", 4
End If

' Hide this form and show the about form.
Me.Hide
frmAbout.Show vbModal

Me.Visible = True

'If (UpdateCheck) Then
'    UpdateTimer.Enabled = True
'End If

Exit Sub
    
MAINLOADERR:
    Handle_Error LANGPACK.SeeByName("LOADERROR") & " " & LANGPACK.ProperString("ERRORNUMBER", Err.Number) & ": " & Err.Description, False

End Sub


Private Sub Form_Unload(Cancel As Integer)

' Make the Skins folder read-only
On Error GoTo SETerr
SetAttr SimsPath & SimsSkinsPath, vbReadOnly
    
End
Exit Sub

SETerr:
    Write_Log "Error while making " & SimsPath & SimsSkinsPath & " read-only. " & Err.Number & ": " & Err.Description, 2

End

End Sub

Private Sub HelpButton_Click()

PopupMenu helpMenu

End Sub


Private Sub helpMenuOption_Click()
    helpForm.Load_Readme
    helpForm.Show
    
End Sub


Private Sub langMenuOption_Click()

'##################################################################
' handle language crap
    
langPickForm.Show vbModal

LANGCHOICE = GetSetting(App.Title, "Settings", "LangChoice")

' Make 'em pick again
While (Not File_Exists(App.Path & "\langs\" & LANGCHOICE))
    langPickForm.Show vbModal
    LANGCHOICE = GetSetting(App.Title, "Settings", "LangChoice")
Wend

'ok, load it
Call Load_Language
'##################################################################

End Sub

Private Sub logMenuOption_Click()

    logOptsForm.Show vbModal
    
End Sub

Private Sub otherMenuOptions_Click()

    optsForm.Show vbModal
    
End Sub

Private Sub rackMenuOption_Click()

On Error Resume Next

maidsChooseform.Show vbModal
    
' set The Rack picture and continue
Dim rackChoice As String
rackChoice = GetSetting(App.Title, "Settings", "RackChoice")
Write_Log "RACK: " & rackChoice, 4
rackPicture.Picture = LoadPicture(App.Path & "\racks\" & rackChoice)
rackPicture.AutoSize = True


End Sub

Private Sub rackPicture_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

        If (Button = 2) Then
            PopupMenu helpMenu
        End If
        
End Sub

Private Sub rackPicture_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)

    ' Make sure we force "X" to be The Rack
    Handle_DnD Data, 3500
    
End Sub

Private Sub sfmwebMenuOption_Click()
    Dim fileName As String, Dummy As String
      Dim BrowserExec As String * 255
      Dim RetVal As Long
      Dim FileNumber As Integer

      ' First, create a known, temporary HTML file
      BrowserExec = Space(255)
      fileName = App.Path & "\temphtm.HTML"
      FileNumber = FreeFile                    ' Get unused file number
      Open fileName For Output As #FileNumber  ' Create temp HTML file
          Write #FileNumber, "<HTML> <\HTML>"  ' Output text
      Close #FileNumber                        ' Close file
      ' Then find the application associated with it
      RetVal = FindExecutable(fileName, Dummy, BrowserExec)
      BrowserExec = Trim(BrowserExec)
      ' If an application is found, launch it!
    If RetVal <= 32 Or IsEmpty(BrowserExec) Then ' Error
          Handle_Error "Sorry, but I could not determine which browser you are using. You will have to go to http://mattwork.potsdam.edu/projects/SimFileMaid/ yourself."
    Else
          RetVal = ShellExecute(Me.hWnd, "open", BrowserExec, _
            "http://mattwork.potsdam.edu/projects/SimFileMaid/", Dummy, SW_SHOWNORMAL)
    End If
    Kill fileName
    
End Sub

Private Sub updateCheckMenuOption_Click()

 '       Write_Log "UPDATE: User requested a check", 4
 '       Check_Updates True
        
End Sub

Private Sub UpdateTimer_Timer()

'    UpdateTimer.Enabled = False
    
'On Error GoTo UPdateerr

'    If (Should_Update()) Then
'        Write_Log "UPDATE: Should, so checking", 4
'        Call Check_Updates
'    End If
'    Exit Sub
'UPdateerr:
'    Write_Log "UPDATE ERROR: " & Err.Number & ": " & Err.Description, 1
    
End Sub
