VERSION 5.00
Begin VB.Form optsForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form1"
   ClientHeight    =   4770
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3900
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4770
   ScaleWidth      =   3900
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Height          =   1455
      Left            =   120
      TabIndex        =   5
      Top             =   2400
      Width           =   3735
      Begin VB.CommandButton FindSimsButton 
         Height          =   495
         Left            =   2880
         Picture         =   "optsForm.frx":0000
         Style           =   1  'Graphical
         TabIndex        =   9
         Top             =   600
         Width           =   735
      End
      Begin VB.CheckBox ForceMyPathBox 
         Caption         =   "Force This Value"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   1080
         Width           =   3495
      End
      Begin VB.TextBox SimsPathText 
         Height          =   405
         Left            =   120
         TabIndex        =   6
         Top             =   600
         Width           =   2655
      End
      Begin VB.Label SimsPathLabel 
         Caption         =   "Where The Sims is Installed:"
         Height          =   375
         Left            =   120
         TabIndex        =   7
         Top             =   240
         Width           =   3495
      End
   End
   Begin VB.CommandButton logButton 
      Default         =   -1  'True
      Height          =   735
      Left            =   120
      Picture         =   "optsForm.frx":030A
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   3960
      Width           =   3735
   End
   Begin VB.Frame Frame1 
      Height          =   2415
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   3735
      Begin VB.CheckBox therackCheck 
         Caption         =   "The Rack"
         Height          =   495
         Left            =   120
         TabIndex        =   10
         Top             =   1680
         Width           =   3495
      End
      Begin VB.CheckBox updateCheckCheck 
         Caption         =   "Skip EXE Files"
         Height          =   495
         Left            =   120
         TabIndex        =   4
         Top             =   1200
         Width           =   3495
      End
      Begin VB.CheckBox skipEXEcheck 
         Caption         =   "Skip EXE Files"
         Height          =   495
         Left            =   120
         TabIndex        =   2
         Top             =   720
         Width           =   3495
      End
      Begin VB.CheckBox confirmOverCheck 
         Caption         =   "Confirm File Overwrites"
         Height          =   495
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   3495
      End
   End
End
Attribute VB_Name = "optsForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' All code Copyright (C) 2002 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.

Private Sub FindSimsButton_Click()

SimsPathText = Get_SimsPath(True)

End Sub

Private Sub Form_Load()

    On Error GoTo optLoadErr
    
    Me.Caption = App.Title & " - Options"
    Me.Icon = mainForm.Icon
    
    'set the langs
    skipEXEcheck.Caption = LANGPACK.SeeByName("SKIPEXEOPT")
    confirmOverCheck.Caption = LANGPACK.SeeByName("CONFIRMOVEROPT")
    updateCheckCheck.Caption = LANGPACK.SeeByName("UPDATECHECK")
    SimsPathLabel.Caption = LANGPACK.SeeByName("SIMSIS")
    ForceMyPathBox.Caption = LANGPACK.SeeByName("FORCEVAL")
    therackCheck.Caption = LANGPACK.SeeByName("THERACK")
    
    
    ' set the other options
    confirmOverCheck.Value = Abs(CInt(ConfirmOverwrites))
    skipEXEcheck.Value = Abs(CInt(SkipEXEs))
    updateCheckCheck.Value = Abs(CInt(UpdateCheck))
    SimsPathText = SimsPath
    ForceMyPathBox.Value = Abs(CInt(ForceMyPath))
    therackCheck.Value = Abs(CInt(TheRack))
    
    'Disable update check
    updateCheckCheck = 0
    updateCheckCheck.Enabled = False
    
    Exit Sub
    
optLoadErr:
    Handle_Error LANGPACK.SeeByName("OTHEROPT") & " " & LANGPACK.ProperString("ERRORNUMBER", Err.Number) & ": " & Err.Description, False

End Sub

Private Sub logButton_Click()

    'ConfirmOverwrites
    If (CBool(confirmOverCheck.Value) <> ConfirmOverwrites) Then
        ConfirmOverwrites = CBool(confirmOverCheck.Value)
        Write_Log "CONFIRMOVERWRITES: Changed by menu to " & CStr(ConfirmOverwrites), 4
        If (ConfirmOverwrites = True) Then
            SaveSetting App.Title, "Settings", "ConfirmOverwrites", "yes"
        Else
            SaveSetting App.Title, "Settings", "ConfirmOverwrites", "no"
        End If
    End If
    
    'SkipEXE
    If (CBool(skipEXEcheck.Value) <> SkipEXEs) Then
        SkipEXEs = CBool(skipEXEcheck.Value)
        Write_Log "SkipEXEs: Changed by menu to " & CStr(SkipEXEs), 4
        If (SkipEXEs = True) Then
            SaveSetting App.Title, "Settings", "SkipEXEs", "yes"
        Else
            SaveSetting App.Title, "Settings", "SkipEXEs", "no"
        End If
    End If
    
    'UpdateCheck
    'If (CBool(updateCheckCheck.Value) <> UpdateCheck) Then
    '    UpdateCheck = CBool(updateCheckCheck.Value)
    '    Write_Log "UpdateCheck: Changed by menu to " & CStr(UpdateCheck), 4
    '    If (UpdateCheck = True) Then
    '        SaveSetting App.Title, "Settings", "UpdateCheck", "yes"
    '    Else
    '        SaveSetting App.Title, "Settings", "UpdateCheck", "no"
    '    End If
    'End If
    
    'ForceMyPath
    If (CBool(ForceMyPathBox.Value) <> ForceMyPath) Then
        ForceMyPath = CBool(ForceMyPathBox.Value)
        Write_Log "ForceMyPath changed by menu to " & CStr(ForceMyPath), 4
        If (ForceMyPath = True) Then
            SaveSetting App.Title, "Settings", "ForceMyPath", "yes"
        Else
            SaveSetting App.Title, "Settings", "ForceMyPath", "no"
        End If
    End If
    
    'The Rack
    If (CBool(therackCheck.Value) <> TheRack) Then
        TheRack = CBool(therackCheck.Value)
        Write_Log "TheRack changed by menu to " & CStr(TheRack), 4
        If (TheRack = True) Then
            SaveSetting App.Title, "Settings", "ShowRack", "yes"
            mainForm.rackMenuOption.Enabled = True
            mainForm.rackPicture.Visible = True
        Else
            SaveSetting App.Title, "Settings", "ShowRack", "no"
            mainForm.rackMenuOption.Enabled = False
            mainForm.rackPicture.Visible = False
        End If
    End If
    
    '****Handle new simspath
    'Confirm new path ends in a "\"
    If (Right(SimsPathText, 1) <> "\") Then
        SimsPathText = SimsPathText & "\"
    End If
    
    'Check for diff in simspaths
    If (LCase(SimsPathText) <> LCase(SimsPath)) Then
        'there's a difference
        Write_Log "SIMSPATH was overridden. New value is: " & SimsPathText, 4
        SaveSetting App.Title, "Settings", "SimsPath", SimsPathText
        SimsPath = SimsPathText
    End If

    
    Unload Me
End Sub
