VERSION 5.00
Begin VB.Form frmAbout 
   BackColor       =   &H00008000&
   BorderStyle     =   0  'None
   Caption         =   "About"
   ClientHeight    =   2520
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5760
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   2520
   ScaleWidth      =   5760
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Visible         =   0   'False
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   7500
      Left            =   1440
      Top             =   1800
   End
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   2535
      Left            =   0
      Picture         =   "frmAbout.frx":0000
      ScaleHeight     =   2535
      ScaleWidth      =   5745
      TabIndex        =   0
      Top             =   0
      Width           =   5745
      Begin VB.PictureBox aboutContainer 
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'None
         Height          =   1575
         Left            =   720
         ScaleHeight     =   1575
         ScaleWidth      =   4935
         TabIndex        =   3
         Top             =   840
         Visible         =   0   'False
         Width           =   4935
         Begin VB.Label aboutLabel 
            BackStyle       =   0  'Transparent
            Caption         =   "Sim File Maid Credits"
            Height          =   1515
            Left            =   120
            TabIndex        =   4
            Top             =   0
            Visible         =   0   'False
            Width           =   4695
            WordWrap        =   -1  'True
         End
      End
      Begin VB.Label copylabel 
         Alignment       =   1  'Right Justify
         BackStyle       =   0  'Transparent
         Caption         =   "Copyright"
         ForeColor       =   &H00FFFFFF&
         Height          =   375
         Left            =   2400
         TabIndex        =   2
         Top             =   2040
         Width           =   3255
      End
      Begin VB.Label versionLabel 
         Alignment       =   1  'Right Justify
         BackStyle       =   0  'Transparent
         Caption         =   "Version"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Left            =   2640
         TabIndex        =   1
         Top             =   1800
         Width           =   3015
      End
   End
End
Attribute VB_Name = "frmAbout"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' All code Copyright (C) 2001 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.


' IF they click the container
Private Sub aboutContainer_Click()
    Unload Me
End Sub

' If they click the label
Private Sub aboutLabel_Click()
    Unload Me
End Sub

' If they click elsewhere on the form
Private Sub Form_Click()
    Unload Me
End Sub

Private Sub Form_Load()

On Error GoTo aboutLoadErr

copylabel.Caption = App.LegalCopyright
versionLabel.Caption = "v" & App.Major & "." & App.Minor & " Build " & App.Revision
Me.Icon = mainForm.Icon
If (CreditsFlag) Then
    ' Roll the credits!
    
    'Load the standard stuff
    aboutLabel = NL & NL & App.Title & " " & versionLabel & NL & "By Matthew Keller" & NL & NL
    aboutLabel = aboutLabel & "Special thanks to:" & NL
    aboutLabel = aboutLabel & "  Carsten Schoeps for the initial autodection of Sim install location," & NL
    aboutLabel = aboutLabel & "  Brian Fletcher (aka GarGan2N) for the idea of The Rack and some beta testing," & NL
    aboutLabel = aboutLabel & "  Info-Zip (www.info-zip.org) for writing great free zip libs," & NL
    aboutLabel = aboutLabel & "  NullSoft (nsis.sf.net) for NSIS (the installer system)," & NL
    aboutLabel = aboutLabel & NL
    
    ' Turn off the copyright and version labels
    copylabel.Visible = False
    versionLabel.Visible = False
    
    ' Add the translators
    Dim CRD As Hash, langs As MArray
    Set CRD = Get_Lang_Headers()
    Set langs = CRD.GetKeys
    aboutLabel = aboutLabel & "Translations:" & NL
    While (langs.Size > 0)
        Dim lang As String, author As String
        lang = langs.Pop
        author = CRD.Value(lang)
        aboutLabel = aboutLabel & "   " & lang & " by " & author & NL
    Wend
    
    ' Add the public thanks
    aboutLabel = aboutLabel & NL & NL & "  And YOU for using The Maid and spreading the word!" & NL
    aboutLabel = aboutLabel & "  So long... " & NL
    
    'Start the scrolling
    aboutLabel.AutoSize = True
    aboutContainer.Visible = True
    aboutLabel.Visible = True
    Timer1.Interval = 50
    Timer1.Enabled = True
    
Else
    'Opening splash
    Timer1.Enabled = True
End If

Exit Sub

aboutLoadErr:
    Handle_Error "Splash " & LANGPACK.ProperString("ERRORNUMBER", Err.Number) & ": " & Err.Description, False


End Sub

Private Sub Form_Unload(Cancel As Integer)

On Error Resume Next
mainForm.Show

End Sub

' If they click the picture
Private Sub Picture1_Click()
    Unload Me
End Sub

Private Sub Timer1_Timer()

If (Not CreditsFlag) Then
    ' Splash screen
    Timer1.Enabled = False
    Unload frmAbout
Else
    ' Credits! Yay! Make it scroll
    aboutLabel.Top = aboutLabel.Top - 5
    If (aboutLabel.Height + aboutLabel.Top < 0) Then
        aboutLabel.Top = 0
    End If
End If

End Sub
