VERSION 5.00
Begin VB.Form logOptsForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form1"
   ClientHeight    =   3345
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3435
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3345
   ScaleWidth      =   3435
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton logButton 
      Default         =   -1  'True
      Height          =   735
      Left            =   120
      Picture         =   "logOptsForm.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   6
      Top             =   2520
      Width           =   3255
   End
   Begin VB.Frame Frame1 
      Height          =   2415
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   3255
      Begin VB.OptionButton logOption 
         Caption         =   "&Debug (Not Recommended)"
         Height          =   375
         Index           =   4
         Left            =   240
         TabIndex        =   5
         Top             =   1800
         Width           =   2775
      End
      Begin VB.OptionButton logOption 
         Caption         =   "&Verbose (Default)"
         Height          =   375
         Index           =   3
         Left            =   240
         TabIndex        =   4
         Top             =   1440
         Width           =   2655
      End
      Begin VB.OptionButton logOption 
         Caption         =   "&Skipped Files Only"
         Height          =   375
         Index           =   2
         Left            =   240
         TabIndex        =   3
         Top             =   1080
         Width           =   2775
      End
      Begin VB.OptionButton logOption 
         Caption         =   "&Errors Only"
         Height          =   375
         Index           =   1
         Left            =   240
         TabIndex        =   2
         Top             =   720
         Width           =   1935
      End
      Begin VB.OptionButton logOption 
         Caption         =   "&Off"
         Height          =   375
         Index           =   0
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Width           =   1935
      End
   End
End
Attribute VB_Name = "logOptsForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' All code Copyright (C) 2002 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.

Dim LL As Integer

Private Sub Form_Load()
Me.Caption = App.Title & " - Logging Options"
Me.Icon = mainForm.Icon

logOption(LogLevel).Value = True
LL = LogLevel

End Sub

Private Sub logButton_Click()

If (LL <> LogLevel) Then
    ' The log level they want, is not the current level
    
    Dim LLN As String
    Select Case LL
        Case 0
            'turns logging off altogether
            LLN = "off"
        Case 1
            'only logs errors
            LLN = "errors"
        Case 2
            'Only log skipped files (and errors)
            LLN = "skips"
        Case 3
            'Logs everything except debugging crap (default)
            LLN = "verbose"
        Case 4
            'Very crazy, you probably don't want this.
            LLN = "debug"
        Case Else
            ' dunno, make it the default
            LLN = "verbose"
            LL = 3
    End Select
    ' Make it the default
    SaveSetting App.Title, "Settings", "LogLevel", LLN
    LogLevel = LL
End If

Unload Me

End Sub

Private Sub logOption_Click(Index As Integer)
    LL = Index
    
End Sub
