VERSION 5.00
Begin VB.Form maidsChooseform 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   5235
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5355
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5235
   ScaleWidth      =   5355
   StartUpPosition =   3  'Windows Default
   Begin VB.OptionButton rackOption 
      Caption         =   "Option1"
      Height          =   3135
      Index           =   0
      Left            =   120
      Picture         =   "maidsChooseform.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   120
      Width           =   1695
   End
   Begin VB.Label rackLabel 
      BackStyle       =   0  'Transparent
      Caption         =   $"maidsChooseform.frx":1CE1
      Height          =   1815
      Left            =   120
      TabIndex        =   0
      Top             =   3360
      Width           =   5175
   End
End
Attribute VB_Name = "maidsChooseform"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' All code Copyright (C) 2002 and Beyond Matthew Keller except
'  where explicitly stated otherwise.
' All code licensed under the GPL. See GPL.txt for details.

Dim racks As MArray
Dim rackChoice As String


Private Sub Form_Load()

On Error GoTo maidsLoadErr
    
Me.Caption = App.Title & " Rack Options"
Me.Icon = mainForm.Icon

rackLabel = LANGPACK.SeeByName("RACKCHOICE")

Dim c As Integer, rackIndex As Integer
Set racks = Get_Files(App.Path & "\racks\*.jpg")
c = 0
rackChoice = GetSetting(App.Title, "Settings", "RackChoice", "0")
If (Len(rackChoice) <= 1) Then
    rackChoice = "0"
End If

' Add all of the racks, making adjustments where necessary
While c < racks.size
    Dim PREV As Integer
    If (c = 0) Then
        PREV = 0
    Else
        PREV = c - 1
    End If
    
    If (c > 0) Then
        ' Create a new option button in the array
        Load rackOption(c)
    End If
    With rackOption(c)
        If (c > 0) Then
            ' Line it up with the last
            .Width = rackOption(PREV).Width
            .Height = rackOption(PREV).Height
            .Left = rackOption(PREV).Left + rackOption(PREV).Width + 10
            .Top = rackOption(PREV).Top
            
            ' Adjust the form width if necessary
            If ((.Left + .Width) >= Me.Width) Then
                Me.Width = .Left + .Width + 120
                rackLabel.Width = Me.Width - 300
            End If
        End If
        'Set the caption and picture, set the tab index
        .Picture = LoadPicture(racks.See(c))
        .Visible = True
        .TabIndex = c + 1
        .Caption = Get_Filename(racks.See(c))
        
        If (rackChoice = .Caption) Then
            .Value = True
        Else
            .Value = False
        End If
        
        ' Strip out the extension
        .Caption = Left(.Caption, Len(.Caption) - 4)
    End With
    c = c + 1
Wend

Exit Sub

maidsLoadErr:
    Handle_Error LANGPACK.SeeByName("RACKOPT") & " " & LANGPACK.ProperString("ERRORNUMBER", Err.Number) & ": " & Err.Description, False


End Sub

Private Sub Form_Unload(Cancel As Integer)
If (rackChoice = "0") Then
    'They didn't pick one, so pick the first in the series.
    rackChoice = Get_Filename(racks.See(0))
    SaveSetting App.Title, "Settings", "RackChoice", rackChoice
Else
    Unload Me
End If
End Sub

Private Sub rackOption_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)

rackChoice = Get_Filename(racks.See(Index))
SaveSetting App.Title, "Settings", "RackChoice", rackChoice
Unload Me
        
End Sub
