;NSIS Script For Sim File Maid

;Compression stuff
SetCompressor bzip2
SetCompress Auto

;Backgound Colors
BGGradient 00FF00 000000 FFFFFF
BrandingText " "

;Title Of Your Application
Name "Sim File Maid"
Icon "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\maid.ICO"

;Do A CRC Check
CRCCheck On

;Output File Name
OutFile "SimFileMaidInstaller.exe"

;License Page Introduction
LicenseText "You should agree with this, before continuing:"

;License Data
LicenseData "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\license.txt"

;The Default Installation Directory
InstallDir "$PROGRAMFILES\Sim File Maid"

;The text to prompt the user to enter a directory
DirText "Please select the folder below"

Section "Install"
  ;Install Files
  SetOutPath $INSTDIR
  SetOverwrite IfNewer
  File "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\SimFileMaid.exe"
  File "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\README.txt"
  File "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\license.txt"
  File "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\gpl.txt"
  File "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\ChangeLog.txt"
  SetOutPath $INSTDIR\langs
  File "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\langs\*.*"
  SetOutPath $INSTDIR\racks
  File "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\racks\*.*"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Sim File Maid" "DisplayName" "Sim File Maid (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Sim File Maid" "UninstallString" "$INSTDIR\Uninst.exe"
  SetOutPath $INSTDIR
  WriteUninstaller "Uninst.exe"
SectionEnd

Section "Shortcuts"
  ;Add Shortcuts
  CreateShortCut "$STARTMENU\Sim File Maid.lnk" "$INSTDIR\SimFileMaid.exe" "" "$INSTDIR\SimFileMaid.exe" 0
SectionEnd

UninstallText "This will uninstall Sim File Maid from your system"

Section Uninstall
  ;Delete Files
  RMDir /r $INSTDIR

  ;Delete Start Menu Shortcuts
  Delete "$STARTMENU\Sim File Maid.lnk"

  ;Delete Uninstaller And Unistall Registry Entries
  Delete "$INSTDIR\Uninst.exe"
  ;DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Sim File Maid"
  DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Sim File Maid"
  RMDir "$INSTDIR"
SectionEnd