;NSIS Script For Maid Helper Files

SetCompressor bzip2

;Perform A Silent Install
SilentInstall silent
BrandingText " "

;Title Of Your Application
Name "Maid Helper Files"
Icon "C:\Program Files\Microsoft Visual Studio\VB98\projects\simzipplus\maid.ICO"

;Do A CRC Check
CRCCheck On

;Output File Name
OutFile "MaidHelper.exe"

;The Default Installation Directory
InstallDir "$SYSDIR"

Section "Install"
  SetAutoClose True
  ;Install Files
  SetOutPath $SYSDIR
  SetOverwrite IfNewer
  File "C:\Windows\system32\unzip32.dll"
  File "C:\Windows\system32\comcat.dll"
  File "C:\Windows\system32\comdlg32.dll"
  File "C:\Windows\system32\comdlg32.ocx"
  File "C:\Windows\system32\mscomctl.ocx"
  File "C:\Windows\system32\msvbvm60.dll"
  File "C:\Windows\system32\oleaut32.dll"
SectionEnd

  Function .onInstSuccess
    MessageBox MB_OK|MB_ICONINFORMATION|MB_TOPMOST|MB_SETFOREGROUND "Helper Files Installed Ok"
  FunctionEnd

  function .onInstFailed
    MessageBox MB_OK|MB_ICONSTOP|MB_TOPMOST|MB_SETFOREGROUND "There was a problem installing helper files. Install/run Sim File Maid, and if that doesn't work, contact the author."
  functionend